<template>
  <v-card :is-empty="isEmpty" card-body-class="px-0">
    <template #empty> Please select the bus stop first </template>
    <h6 class="card-title mt-2 px-4">{{ title }}</h6>
    <v-table
      row-class="cursor-pointer"
      :items="busStops"
      @row-clicked="
        $emit('update:selected-bus-stop', ($event as BusStopGroup).name)
      "
      :headers="[{ title: 'Bus Stops', sortBy: 'name' }]"
    >
      <template #header>
        <th scope="col">Bus Stops</th>
      </template>
      <template #row="{ item }">
        <td>{{ (item as BusStopGroup).name }}</td>
      </template>
    </v-table>
  </v-card>
</template>

<script setup lang="ts">
import VCard from '@/ui/v-card/VCard.vue';
import VTable from '@/ui/v-table/VTable.vue';
import { BusStopGroup } from '@/services/stops/stops.types';
import { computed } from 'vue';

const props = defineProps<{
  busLine?: number;
  busLineStops: BusStopGroup[];
  selectedBusStop?: string;
}>();

defineEmits<{
  (e: 'update:selected-bus-stop', busStop: string): void;
}>();

const title = computed(() => {
  return `Bus Line: ${props.busLine}`;
});

const busStops = computed(() => {
  return props.busLineStops.slice().sort((a, b) => (a.name > b.name ? 1 : -1));
});

const isEmpty = computed(() => {
  return props.busLineStops.length === 0;
});
</script>
